diff --git a/rsvg-filter.c b/rsvg-filter.c
index 705f14c..81cce75 100644
--- a/rsvg-filter.c
+++ b/rsvg-filter.c
@@ -4186,28 +4746,19 @@ rsvg_filter_primitive_specular_lighting_render (RsvgFilterPrimitive * self, Rsvg
             if (max < 0)
                 max = 0;
 
-            output_pixels[y * rowstride + x * 4 + ctx->channelmap[0]] = lightcolour.x * max;
-            output_pixels[y * rowstride + x * 4 + ctx->channelmap[1]] = lightcolour.y * max;
-            output_pixels[y * rowstride + x * 4 + ctx->channelmap[2]] = lightcolour.z * max;
+            output_pixels[y * rowstride + x * 4 + ctx->channelmap[0]] = lightcolor.x * max;
+            output_pixels[y * rowstride + x * 4 + ctx->channelmap[1]] = lightcolor.y * max;
+            output_pixels[y * rowstride + x * 4 + ctx->channelmap[2]] = lightcolor.z * max;
             output_pixels[y * rowstride + x * 4 + ctx->channelmap[3]] = max;
 
         }
 
-    rsvg_filter_store_result (self->result, output, ctx);
-
-    g_object_unref (G_OBJECT (in));
-    g_object_unref (G_OBJECT (output));
-}
+    cairo_surface_mark_dirty (output);
 
-static void
-rsvg_filter_primitive_specular_lighting_free (RsvgNode * self)
-{
-    RsvgFilterPrimitiveSpecularLighting *upself;
+    rsvg_filter_store_result (self->result, output, ctx);
 
-    upself = (RsvgFilterPrimitiveSpecularLighting *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
-    _rsvg_node_free (self);
+    cairo_surface_destroy (in);
+    cairo_surface_destroy (output);
 }
 
 static void
@@ -4233,7 +4784,7 @@ rsvg_filter_primitive_specular_lighting_set_atts (RsvgNode * self, RsvgHandle *
         if ((value = rsvg_property_bag_lookup (atts, "height")))
             filter->super.height = _rsvg_css_parse_length (value);
         if ((value = rsvg_property_bag_lookup (atts, "lighting-color")))
-            filter->lightingcolour = rsvg_css_parse_color (value, 0);
+            filter->lightingcolor = rsvg_css_parse_color (value, 0);
         if ((value = rsvg_property_bag_lookup (atts, "specularConstant")))
             filter->specularConstant = g_ascii_strtod (value, NULL);
         if ((value = rsvg_property_bag_lookup (atts, "specularExponent")))
@@ -4251,7 +4802,7 @@ rsvg_new_filter_primitive_specular_lighting (void)
 {
     RsvgFilterPrimitiveSpecularLighting *filter;
     filter = g_new (RsvgFilterPrimitiveSpecularLighting, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_SPECULAR_LIGHTING);
     filter->super.in = g_string_new ("none");
     filter->super.result = g_string_new ("none");
     filter->super.x.factor = filter->super.y.factor = filter->super.width.factor =
@@ -4259,9 +4810,9 @@ rsvg_new_filter_primitive_specular_lighting (void)
     filter->surfaceScale = 1;
     filter->specularConstant = 1;
     filter->specularExponent = 1;
-    filter->lightingcolour = 0xFFFFFFFF;
-    filter->super.render = &rsvg_filter_primitive_specular_lighting_render;
-    filter->super.super.free = &rsvg_filter_primitive_specular_lighting_free;
+    filter->lightingcolor = 0xFFFFFFFF;
+    filter->super.render = rsvg_filter_primitive_specular_lighting_render;
+    filter->super.super.free = rsvg_filter_primitive_free;
     filter->super.super.set_atts = rsvg_filter_primitive_specular_lighting_set_atts;
     return (RsvgNode *) filter;
 }
@@ -4296,25 +4847,27 @@ rsvg_filter_primitive_tile_render (RsvgFilterPrimitive * self, RsvgFilterContext
     guchar *in_pixels;
     guchar *output_pixels;
 
-    GdkPixbuf *output;
-    GdkPixbuf *in;
-
-    RsvgFilterPrimitiveTile *upself;
+    cairo_surface_t *output, *in;
 
-    upself = (RsvgFilterPrimitiveTile *) self;
     oboundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     input = rsvg_filter_get_result (self->in, ctx);
-    in = input.result;
+    in = input.surface;
     boundarys = input.bounds;
 
+    cairo_surface_flush (in);
 
-    in_pixels = gdk_pixbuf_get_pixels (in);
+    in_pixels = cairo_image_surface_get_data (in);
+
+    output = _rsvg_image_surface_new (ctx->width, ctx->height);
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, ctx->width, ctx->height);
-    rowstride = gdk_pixbuf_get_rowstride (output);
+    rowstride = cairo_image_surface_get_stride (output);
 
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    output_pixels = cairo_image_surface_get_data (output);
 
     for (y = oboundarys.y0; y < oboundarys.y1; y++)
         for (x = oboundarys.x0; x < oboundarys.x1; x++)
@@ -4326,20 +4879,12 @@ rsvg_filter_primitive_tile_render (RsvgFilterPrimitive * self, RsvgFilterContext
                                boundarys.y0) * rowstride + i];
             }
 
-    rsvg_filter_store_result (self->result, output, ctx);
-
-    g_object_unref (G_OBJECT (output));
-}
+    cairo_surface_mark_dirty (output);
 
-static void
-rsvg_filter_primitive_tile_free (RsvgNode * self)
-{
-    RsvgFilterPrimitiveTile *upself;
+    rsvg_filter_store_result (self->result, output, ctx);
 
-    upself = (RsvgFilterPrimitiveTile *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
-    _rsvg_node_free (self);
+    cairo_surface_destroy (in);
+    cairo_surface_destroy (output);
 }
 
 static void
@@ -4373,13 +4918,13 @@ rsvg_new_filter_primitive_tile (void)
 {
     RsvgFilterPrimitiveTile *filter;
     filter = g_new (RsvgFilterPrimitiveTile, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_TILE);
     filter->super.in = g_string_new ("none");
     filter->super.result = g_string_new ("none");
     filter->super.x.factor = filter->super.y.factor = filter->super.width.factor =
         filter->super.height.factor = 'n';
-    filter->super.render = &rsvg_filter_primitive_tile_render;
-    filter->super.super.free = &rsvg_filter_primitive_tile_free;
+    filter->super.render = rsvg_filter_primitive_tile_render;
+    filter->super.super.free = rsvg_filter_primitive_free;
     filter->super.super.set_atts = rsvg_filter_primitive_tile_set_atts;
     return (RsvgNode *) filter;
 }
diff --git a/rsvg-filter.h b/rsvg-filter.h
index 280f6a9..da7ffeb 100644
--- a/rsvg-filter.h
+++ b/rsvg-filter.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-filter.h : Provides filters
 
@@ -27,54 +28,69 @@
 
 #include "rsvg.h"
 #include "rsvg-defs.h"
-#include <libxml/SAX.h>
 
 G_BEGIN_DECLS 
 
+typedef struct  {
+    int x0, y0, x1, y1;
+} RsvgIRect;
+
 typedef RsvgCoordUnits RsvgFilterUnits;
 
 struct _RsvgFilter {
     RsvgNode super;
-    int refcnt;
     RsvgLength x, y, width, height;
     RsvgFilterUnits filterunits;
     RsvgFilterUnits primitiveunits;
 };
 
-GdkPixbuf   *rsvg_filter_render	    (RsvgFilter * self, GdkPixbuf * source, GdkPixbuf * bg,
-				     RsvgDrawingCtx * context, RsvgBbox * dimentions, char *channelmap);
+G_GNUC_INTERNAL
+cairo_surface_t *rsvg_filter_render (RsvgFilter *self,
+                                     cairo_surface_t *source,
+                                     RsvgDrawingCtx *context, 
+                                     RsvgBbox *dimentions, 
+                                     char *channelmap);
 
+G_GNUC_INTERNAL
 RsvgNode    *rsvg_new_filter	    (void);
-RsvgFilter  *rsvg_filter_parse	    (const RsvgDefs * defs, const char *str);
-
-RsvgNode    *rsvg_new_filter_primitive_blend		    (void);
-RsvgNode    *rsvg_new_filter_primitive_convolve_matrix	    (void);
-RsvgNode    *rsvg_new_filter_primitive_gaussian_blur	    (void);
-RsvgNode    *rsvg_new_filter_primitive_offset		    (void);
-RsvgNode    *rsvg_new_filter_primitive_merge		    (void);
-RsvgNode    *rsvg_new_filter_primitive_merge_node	    (void);
-RsvgNode    *rsvg_new_filter_primitive_colour_matrix	    (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_blend                (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_convolve_matrix      (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_gaussian_blur        (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_offset               (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_merge                (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_merge_node           (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_color_matrix        (void);
+G_GNUC_INTERNAL
 RsvgNode    *rsvg_new_filter_primitive_component_transfer   (void);
-RsvgNode    *rsvg_new_node_component_transfer_function	    (char channel);
-RsvgNode    *rsvg_new_filter_primitive_erode		    (void);
-RsvgNode    *rsvg_new_filter_primitive_composite	    (void);
-RsvgNode    *rsvg_new_filter_primitive_flood		    (void);
-RsvgNode    *rsvg_new_filter_primitive_displacement_map	    (void);
-RsvgNode    *rsvg_new_filter_primitive_turbulence	    (void);
-RsvgNode    *rsvg_new_filter_primitive_image		    (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_node_component_transfer_function      (char channel);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_erode                (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_composite            (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_flood                (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_displacement_map     (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_turbulence           (void);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_image                (void);
+G_GNUC_INTERNAL
 RsvgNode    *rsvg_new_filter_primitive_diffuse_lighting	    (void);
-RsvgNode    *rsvg_new_filter_primitive_light_source	    (char type);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_node_light_source	                    (char type);
+G_GNUC_INTERNAL
 RsvgNode    *rsvg_new_filter_primitive_specular_lighting    (void);
-RsvgNode    *rsvg_new_filter_primitive_tile		    (void);
-
-void	     rsvg_filter_adobe_blend	(gint modenum, GdkPixbuf * in, GdkPixbuf * bg,
-					 GdkPixbuf * output, RsvgIRect boundarys, 
-					 RsvgDrawingCtx * ctx);
-void	     rsvg_alpha_blt		(GdkPixbuf * src, gint srcx, gint srcy,
-					 gint srcwidth, gint srcheight, 
-					 GdkPixbuf * dst, gint dstx, gint dsty);
-void	     rsvg_art_affine_image	(const GdkPixbuf * img, GdkPixbuf * intermediate,
-					 double *affine, double w, double h);
+G_GNUC_INTERNAL
+RsvgNode    *rsvg_new_filter_primitive_tile                 (void);
 
 G_END_DECLS
 
diff --git a/rsvg-gobject.c b/rsvg-gobject.c
index 045640f..5639e77 100644
--- a/rsvg-gobject.c
+++ b/rsvg-gobject.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-gobject.c: GObject support.
 
@@ -20,11 +21,29 @@
    Boston, MA 02111-1307, USA.
 */
 
+/**
+ * SECTION: rsvg-handle
+ * @short_description: Create and manipulate SVG objects
+ *
+ * librsvg is a component used within software applications to enable
+ * support for SVG-format scalable graphics. In contrast to raster
+ * formats, scalable vector graphics provide users and artists a way
+ * to create, view, and provide imagery that is not limited to the
+ * pixel or dot density that an output device is capable of.
+ *
+ * Many software developers use the librsvg library to render
+ * SVG graphics. It is lightweight and portable.
+ */
+
+#include "config.h"
+
 #include "rsvg-private.h"
 #include "rsvg-defs.h"
+#include "rsvg.h"
 
 enum {
     PROP_0,
+    PROP_FLAGS,
     PROP_DPI_X,
     PROP_DPI_Y,
     PROP_BASE_URI,
@@ -41,63 +60,56 @@ enum {
 extern double rsvg_internal_dpi_x;
 extern double rsvg_internal_dpi_y;
 
-static GObjectClass *rsvg_parent_class = NULL;
+G_DEFINE_TYPE (RsvgHandle, rsvg_handle, G_TYPE_OBJECT)
 
 static void
-instance_init (RsvgHandle * self)
+rsvg_handle_init (RsvgHandle * self)
 {
-    self->priv = g_new0 (RsvgHandlePrivate, 1);
-    self->priv->defs = rsvg_defs_new ();
+    self->priv = G_TYPE_INSTANCE_GET_PRIVATE (self, RSVG_TYPE_HANDLE, RsvgHandlePrivate);
+
+    self->priv->flags = RSVG_HANDLE_FLAGS_NONE;
+    self->priv->load_policy = RSVG_LOAD_POLICY_DEFAULT;
+    self->priv->defs = rsvg_defs_new (self);
     self->priv->handler_nest = 0;
-    self->priv->entities = g_hash_table_new (g_str_hash, g_str_equal);
+    self->priv->entities = g_hash_table_new_full (g_str_hash, 
+                                                  g_str_equal,
+                                                  g_free,
+                                                  (GDestroyNotify) xmlFreeNode);
     self->priv->dpi_x = rsvg_internal_dpi_x;
     self->priv->dpi_y = rsvg_internal_dpi_y;
 
-    self->priv->css_props = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
+    self->priv->css_props = g_hash_table_new_full (g_str_hash,
+                                                   g_str_equal,
+                                                   g_free,
+                                                   (GDestroyNotify) g_hash_table_destroy);
 
     self->priv->ctxt = NULL;
     self->priv->currentnode = NULL;
     self->priv->treebase = NULL;
 
     self->priv->finished = 0;
+#if GLIB_CHECK_VERSION (2, 24, 0)
+    self->priv->data_input_stream = NULL;
+#else
+    self->priv->gzipped_data = NULL;
+#endif
     self->priv->first_write = TRUE;
+    self->priv->cancellable = NULL;
 
     self->priv->is_disposed = FALSE;
     self->priv->in_loop = FALSE;
 }
 
 static void
-rsvg_ctx_free_helper (gpointer key, gpointer value, gpointer user_data)
-{
-    xmlEntityPtr entval = (xmlEntityPtr) value;
-
-#if LIBXML_VERSION < 20700
-    /* key == entval->name, so it's implicitly freed below */
-
-    xmlFree ((xmlChar *) entval->name);
-    xmlFree ((xmlChar *) entval->ExternalID);
-    xmlFree ((xmlChar *) entval->SystemID);
-    xmlFree (entval->content);
-    xmlFree (entval->orig);
-    xmlFree (entval);
-#else
-	xmlFreeNode(entval);
-#endif
-}
-
-static void
-instance_dispose (GObject * instance)
+rsvg_handle_dispose (GObject *instance)
 {
     RsvgHandle *self = (RsvgHandle *) instance;
 
-    self->priv->is_disposed = TRUE;
+    if (self->priv->is_disposed)
+      goto chain;
 
-#if HAVE_SVGZ
-    if (self->priv->is_gzipped)
-        g_object_unref (G_OBJECT (self->priv->gzipped_data));
-#endif
+    self->priv->is_disposed = TRUE;
 
-    g_hash_table_foreach (self->priv->entities, rsvg_ctx_free_helper, NULL);
     g_hash_table_destroy (self->priv->entities);
     rsvg_defs_free (self->priv->defs);
     g_hash_table_destroy (self->priv->css_props);
@@ -114,17 +126,40 @@ instance_dispose (GObject * instance)
     if (self->priv->base_uri)
         g_free (self->priv->base_uri);
 
-    g_free (self->priv);
+#if GLIB_CHECK_VERSION (2, 24, 0)
+    if (self->priv->base_gfile) {
+        g_object_unref (self->priv->base_gfile);
+        self->priv->base_gfile = NULL;
+    }
+    if (self->priv->data_input_stream) {
+        g_object_unref (self->priv->data_input_stream);
+        self->priv->data_input_stream = NULL;
+    }
+#else
+    if (self->priv->gzipped_data) {
+        g_object_unref (self->priv->gzipped_data);
+        self->priv->gzipped_data = NULL;
+    }
+#endif
+
+    if (self->priv->cancellable) {
+        g_object_unref (self->priv->cancellable);
+        self->priv->cancellable = NULL;
+    }
 
-    rsvg_parent_class->dispose (G_OBJECT (self));
+  chain:
+    G_OBJECT_CLASS (rsvg_handle_parent_class)->dispose (instance);
 }
 
 static void
-set_property (GObject * instance, guint prop_id, GValue const *value, GParamSpec * pspec)
+rsvg_handle_set_property (GObject * instance, guint prop_id, GValue const *value, GParamSpec * pspec)
 {
     RsvgHandle *self = RSVG_HANDLE (instance);
 
     switch (prop_id) {
+    case PROP_FLAGS:
+        self->priv->flags = g_value_get_flags (value);
+        break;
     case PROP_DPI_X:
         rsvg_handle_set_dpi_x_y (self, g_value_get_double (value), self->priv->dpi_y);
         break;
@@ -140,12 +175,15 @@ set_property (GObject * instance, guint prop_id, GValue const *value, GParamSpec
 }
 
 static void
-get_property (GObject * instance, guint prop_id, GValue * value, GParamSpec * pspec)
+rsvg_handle_get_property (GObject * instance, guint prop_id, GValue * value, GParamSpec * pspec)
 {
     RsvgHandle *self = RSVG_HANDLE (instance);
     RsvgDimensionData dim;
 
     switch (prop_id) {
+    case PROP_FLAGS:
+        g_value_set_flags (value, self->priv->flags);
+        break;
     case PROP_DPI_X:
         g_value_set_double (value, self->priv->dpi_x);
         break;
@@ -186,21 +224,31 @@ get_property (GObject * instance, guint prop_id, GValue * value, GParamSpec * ps
 }
 
 static void
-class_init (RsvgHandleClass * klass)
+rsvg_handle_class_init (RsvgHandleClass * klass)
 {
     GObjectClass *gobject_class = G_OBJECT_CLASS (klass);
 
-    /* hook gobject vfuncs */
-    gobject_class->dispose = instance_dispose;
-
-    rsvg_parent_class = (GObjectClass *) g_type_class_peek_parent (klass);
-
-    gobject_class->set_property = set_property;
-    gobject_class->get_property = get_property;
-
-        /**
-	 * dpi-x:
-	 */
+    gobject_class->dispose = rsvg_handle_dispose;
+    gobject_class->set_property = rsvg_handle_set_property;
+    gobject_class->get_property = rsvg_handle_get_property;
+
+    /**
+     * RsvgHandle:flags:
+     * 
+     * Flags from #RsvgHandleFlags.
+     * 
+     * Since: 2.36
+     */
+    g_object_class_install_property (gobject_class,
+                                     PROP_FLAGS,
+                                     g_param_spec_flags ("flags", NULL, NULL,
+                                                         RSVG_TYPE_HANDLE_FLAGS,
+                                                         RSVG_HANDLE_FLAGS_NONE,
+                                                         G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
+
+    /**
+     * dpi-x:
+     */
     g_object_class_install_property (gobject_class,
                                      PROP_DPI_X,
                                      g_param_spec_double ("dpi-x", _("Horizontal resolution"),
@@ -248,72 +296,63 @@ class_init (RsvgHandleClass * klass)
                                                           _("ex"), 0, G_MAXDOUBLE, 0,
                                                           (GParamFlags) (G_PARAM_READABLE)));
 
+    /**
+     * RsvgHandle:title:
+     *
+     * SVG's description
+     *
+     * Deprecated: 2.36
+     */
     g_object_class_install_property (gobject_class,
                                      PROP_TITLE,
                                      g_param_spec_string ("title", _("Title"),
                                                           _("SVG file title"), NULL,
                                                           (GParamFlags) (G_PARAM_READABLE)));
 
+    /**
+     * RsvgHandle:desc:
+     *
+     * SVG's description
+     *
+     * Deprecated: 2.36
+     */
     g_object_class_install_property (gobject_class,
                                      PROP_DESC,
                                      g_param_spec_string ("desc", _("Description"),
                                                           _("SVG file description"), NULL,
                                                           (GParamFlags) (G_PARAM_READABLE)));
 
+    /**
+     * RsvgHandle:metadata:
+     *
+     * SVG's description
+     *
+     * Deprecated: 2.36
+     */
     g_object_class_install_property (gobject_class,
                                      PROP_METADATA,
                                      g_param_spec_string ("metadata", _("Metadata"),
                                                           _("SVG file metadata"), NULL,
                                                           (GParamFlags) (G_PARAM_READABLE)));
 
-    rsvg_SAX_handler_struct_init ();
-}
-
-const GTypeInfo rsvg_type_info = {
-    sizeof (RsvgHandleClass),
-    NULL,                       /* base_init */
-    NULL,                       /* base_finalize */
-    (GClassInitFunc) class_init,
-    NULL,                       /* class_finalize */
-    NULL,                       /* class_data */
-    sizeof (RsvgHandle),
-    0,                          /* n_preallocs */
-    (GInstanceInitFunc) instance_init,
-};
+    g_type_class_add_private (klass, sizeof (RsvgHandlePrivate));
 
-static GType rsvg_type = 0;
-
-/* HACK to get around bugs 357406 and 362217. private API for now. */
-GType
-_rsvg_register_types (GTypeModule * module)
-{
-    rsvg_type = g_type_module_register_type (module,
-                                             G_TYPE_OBJECT,
-                                             "RsvgHandle", &rsvg_type_info, (GTypeFlags) 0);
-    return rsvg_type;
-}
+    xmlInitParser ();
 
-GType
-rsvg_handle_get_type (void)
-{
-    if (!rsvg_type) {
-        rsvg_type =
-            g_type_register_static (G_TYPE_OBJECT, "RsvgHandle", &rsvg_type_info, (GTypeFlags) 0);
-    }
-    return rsvg_type;
+    rsvg_SAX_handler_struct_init ();
 }
 
 /**
  * rsvg_handle_free:
  * @handle: An #RsvgHandle
  *
- * Frees #handle.
+ * Frees @handle.
  * Deprecated: Use g_object_unref() instead.
  **/
 void
 rsvg_handle_free (RsvgHandle * handle)
 {
-    g_object_unref (G_OBJECT (handle));
+    g_object_unref (handle);
 }
 
 /**
@@ -333,3 +372,22 @@ rsvg_handle_new (void)
 {
     return RSVG_HANDLE (g_object_new (RSVG_TYPE_HANDLE, NULL));
 }
+
+
+/**
+ * rsvg_handle_new_with_flags:
+ * @flags: flags from #RsvgHandleFlags
+ *
+ * Creates a new #RsvgHandle with flags @flags.
+ *
+ * Returns: (transfer full): a new #RsvgHandle
+ * 
+ * Since: 2.36
+ **/
+RsvgHandle *
+rsvg_handle_new_with_flags (RsvgHandleFlags flags)
+{
+    return g_object_new (RSVG_TYPE_HANDLE, 
+                         "flags", flags,
+                         NULL);
+}
